SCRAM-SHA3-512 and SCRAM-SHA3-512-PLUS Simple Authentication and Security Layer (SASL) Mechanisms
Alexey Melnikov, Ed.
Isode Ltd
14 Castle Mews
Hampton
Middlesex
TW12 2NP
UK
alexey.melnikov@isode.com
2024
This document registers the Simple Authentication and Security Layer (SASL) mechanisms SCRAM-SHA3-512 and SCRAM-SHA3-512-PLUS.

Introduction
This document registers 2 new SASL [RFC4422] mechanisms SCRAM-SHA3-512 and SCRAM-SHA3-512-PLUS, which are variants of Salted Challenge Response Authentication Mechanism (SCRAM) [RFC5802]. SHA3-512 has stronger security properties than SHA-1, and it is expected that SCRAM mechanisms based on it will have greater predicted longevity than the SCRAM mechanisms based on SHA-1. SHA3-512 works differently from SHA-2 family of hash functions, so it is also expected that vulnerabilities in SHA-2 hash functions are not going to necessarily affect SHA-3 family of hash functions.

Key Word Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all

SCRAM-SHA3-512 and SCRAM-SHA3-512-PLUS
The SCRAM-SHA3-512 and SCRAM-SHA3-512-PLUS SASL mechanisms are defined in the same way that SCRAM-SHA-1 and SCRAM-SHA-1-PLUS are defined in [RFC5802], except that the hash function for HMAC() and H() uses SHA3-512 [NIST.FIPS.202] instead of SHA-1.
For the SCRAM-SHA3-512 and SCRAM-SHA3-512-PLUS SASL mechanisms, the hash iteration-count announced by a server SHOULD be at least 10000.
The GSS-API mechanism OID for SCRAM-SHA3-512 is 1.3.6.1.5.5.<TBD> (see Section 5).
[[TBD: add an example.]]

Security Considerations
The security considerations from [RFC5802] still apply.
To be secure, SCRAM-SHA3-512-PLUS MUST be used over a TLS channel that has had the session hash extension [RFC7627] negotiated, or session resumption MUST NOT have been used.
When using SCRAM over TLS 1.2 [RFC5246], the "tls-unique" channel binding is still the default channel binding to use (see Section 6.1 of [RFC5802]), assuming the above conditions are satisfied.
As "tls-unique" channel binding is not defined for TLS 1.3 [RFC8446], when using SCRAM over TLS 1.3, the "tls-exporter" channel binding [RFC9266] MUST be the default channel binding (in the sense specified in Section 6.1 of [RFC5802]) to use.
See [RFC4270] and [RFC6194] for reasons to move from SHA-1 to a stronger security mechanism like SHA3-512.
The strength of this mechanism is dependent in part on the hash iteration-count, as denoted by "i" in [RFC5802]. As a rule of thumb, the hash iteration-count should be such that a modern machine will take 0.1 seconds to perform the complete algorithm; however, this is unlikely to be practical on mobile devices and other relatively low- performance systems.
At the time this was written, the rule of thumb gives around 15,000 iterations required; however, a hash iteration- count of 10000 takes around 0.5 seconds on current mobile handsets. This computational cost can be avoided by caching the ClientKey (assuming the Salt and hash iteration-count is stable). Therefore, the recommendation of this specification is that the hash iteration- count SHOULD be at least 10000, but careful consideration ought to be given to using a significantly higher value, particularly where mobile use is less important.

IANA Considerations
IANA is requested to add the following new SASL SCRAM mechanisms to the "SASL SCRAM Family Mechanisms" registry:
  To: iana@iana.org
  Subject: Registration of a new SASL SCRAM Family mechanism SCRAM-SHA3-512
  SASL mechanism name (or prefix for the family): SCRAM-SHA3-512
  Security considerations: Section 4 of RFC XXXX
  Published specification (optional, recommended): RFC XXXX
  Minimum iteration-count: 10000
  OID: 1.3.6.1.5.5.<TBD>
  Person & email address to contact for further information: IETF KITTEN WG <kitten@ietf.org>
  Intended usage: COMMON
  Owner/Change controller: IESG <iesg@ietf.org>
  Note:
  To: iana@iana.org
  Subject: Registration of a new SASL SCRAM Family mechanism SCRAM-SHA3-512-PLUS
  SASL mechanism name (or prefix for the family): SCRAM-SHA3-512-PLUS
  Security considerations: Section 4 of RFC XXXX
  Published specification (optional, recommended): RFC XXXX
  Minimum iteration-count: 10000
  OID: 1.3.6.1.5.5.<TBD>
  Person & email address to contact for further information: IETF KITTEN WG <kitten@ietf.org>
  Intended usage: COMMON
  Owner/Change controller: IESG <iesg@ietf.org>
  Note:

Normative References
[NIST.FIPS.202]

SHA-3 Standard: Permutation-Based Hash and Extendable-Output Functions
Morris J. Dworkin
National Institute of Standards and Technology
August 2015
FIPS PUB 202
DOI 10.6028/nist.fips.202

Informative References
[RFC4422]
[RFC5802]
[RFC2119]
[RFC8174]
[RFC7627]
[RFC5246]
[RFC8446]
[RFC9266]
[RFC4270]
[RFC6194]

Acknowledgements
This document is based on RFC 7677 by Tony Hansen.
Thank you to Ludovic Bocquet for comments and corrections.